﻿using UnityEngine;
using System.Collections;

public class CameraMaintainer : MonoBehaviour
{

    public GameObject trainToFollow;
    private float zoomLevel;
    private Vector3 startingPosition;

    // Use this for initialization
    void Start()
    {
        zoomLevel = camera.orthographicSize;
    }

    // Update is called once per frame
    void Update()
    {
        CheckIfTrainIsGoingOutside();
    }

    public void CheckIfTrainIsGoingOutside()
    {
        Vector3 trainPosition = trainToFollow.transform.position - startingPosition;
        if (Mathf.Abs(trainPosition.x) + 8.5f > zoomLevel * 1.75f)
        {
            zoomLevel = (Mathf.Abs(trainPosition.x) + 8.5f) / 1.75f;
        }
        if (Mathf.Abs(trainPosition.y) + 5 > zoomLevel)
        {
            zoomLevel = Mathf.Abs(trainPosition.y) + 5;
        }
        camera.orthographicSize = zoomLevel;
    }

    public void PrepareForStart(Wagon firstWagon)
    {
        trainToFollow = firstWagon.gameObject;
        startingPosition = trainToFollow.transform.position;
        transform.position = startingPosition + new Vector3(0, 0, -10);
    }
}
