﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CityPrefab : MonoBehaviour {

    private static GameObject nameLabel;

    static Sprite citySprite;

    public string CityName { get; private set; }
    public WagonDirection GetOutDirection { get; private set; }
    public RailField GetOutField { get; private set; }
    public List<ThingAndPrice> ThingsForSell { get; private set; }

    private int x;
    private int y;

	// Use this for initialization
	void Awake () {
        if (citySprite == null)
        {
            citySprite = Resources.Load<Sprite>("tiles/city");
        }
	}
	
	// Update is called once per frame
	void Update () {
	
	}

    public void Config(int x, int y, string name)
    {
        this.x = x;
        this.y = y;
        this.CityName = name;
        transform.position = new Vector3(x, -1 * y);
        transform.GetComponent<SpriteRenderer>().sprite = citySprite;
        FillThingsForSell();
    }

    private void FillThingsForSell()
    {
        ThingsForSell = new List<ThingAndPrice>();

        int lackOfTypeIndex = Random.Range(0,4);        

        ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Coal, true, x, y));
        if (lackOfTypeIndex != 0)
        {
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Food, false, x, y));
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Food, true, x, y));
        }
        if (lackOfTypeIndex != 1)
        {
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Ammo, false, x, y));
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Ammo, true, x, y));
        }
        if (lackOfTypeIndex != 2)
        {
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Drugs, false, x, y));
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Drugs, true, x, y));
        }
        if (lackOfTypeIndex != 3)
        {
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Luxuries, false, x, y));
            ThingsForSell.Add(new ThingAndPrice(ResourcesTypes.Luxuries, true, x, y));
        }
    }

    public void FindOutDirections()
    {
        if (MapMaintainer.Instance.FindField(x, y - 1) != null) // góra
        {
            GetOutField = MapMaintainer.Instance.FindField(x, y - 2);
            GetOutDirection = WagonDirection.TopRight;
            transform.eulerAngles = new Vector3(0, 0, 90);
        }
        if (MapMaintainer.Instance.FindField(x + 1, y) != null) // prawo
        {
            GetOutField = MapMaintainer.Instance.FindField(x + 2, y);
            GetOutDirection = WagonDirection.TopRight;
        }
        if (MapMaintainer.Instance.FindField(x, y + 1) != null) // dół
        {
            GetOutField = MapMaintainer.Instance.FindField(x, y + 2);
            GetOutDirection = WagonDirection.BottomLeft;
            transform.eulerAngles = new Vector3(0, 0, -90);
        }
        if (MapMaintainer.Instance.FindField(x - 1, y) != null) // lewo
        {
            GetOutField = MapMaintainer.Instance.FindField(x - 2, y);
            GetOutDirection = WagonDirection.BottomLeft;
            transform.eulerAngles = new Vector3(0, 0, 180);
        }
    }

    public void OnMouseHover()
    {
        ClickMaintainer.Instance.ChangeCityLabel(new Vector3(x,-1*y),CityName);
    }

    public void OnMouseHoverOff()
    {
        ClickMaintainer.Instance.HideCityLabel();
    }
}