﻿using UnityEngine;
using System.Collections;

public enum RailsTypes { H, V, Q1, Q2, Q3, Q4 }

public class RailPrefab : MonoBehaviour
{

    static Sprite[] rails00;
    private RailField itsRailField;

    // Use this for initialization
    void Awake()
    {
        if (rails00 == null)
        {
            rails00 = Resources.LoadAll<Sprite>("tiles/rails00");
        }
    }

    // Update is called once per frame
    void Update()
    {
    }

    public void Config(int x, int y, RailsTypes type, RailField itsRailField)
    {
        this.itsRailField = itsRailField;
        transform.position = new Vector3(x, -1 * y);
        ChangeType(type);
    }

    public void ChangeType(RailsTypes type)
    {
        Sprite spriteToSet;
        switch (type)
        {
            case RailsTypes.V: spriteToSet = rails00[0]; break;
            case RailsTypes.H: spriteToSet = rails00[1]; break;
            case RailsTypes.Q1: spriteToSet = rails00[2]; break;
            case RailsTypes.Q2: spriteToSet = rails00[3]; break;
            case RailsTypes.Q3: spriteToSet = rails00[4]; break;
            case RailsTypes.Q4: spriteToSet = rails00[5]; break;
            default: spriteToSet = rails00[0]; break;
        }
        transform.GetComponent<SpriteRenderer>().sprite = spriteToSet;
    }

    public void OnMouseHover()
    {
        if (itsRailField.Switchable)
        {
            RailFieldHover.Instance.Show(transform.position);
        }
    }

    public void OnMouseHoverOff()
    {
        RailFieldHover.Instance.Hide();
    }

    public void OnLeftClick()
    {
        if (itsRailField.Switchable)
        {
            itsRailField.Switch();
        }
    }
}
