﻿using UnityEngine;
using System.Collections;

public enum ResourcesTypes { Coal, Drugs, Food, Luxuries, Ammo }

public class ThingAndPrice {

    public ResourcesTypes TypeOfRes { get; private set; }
    public bool IsWagon { get; private set; }
    public int Price { get; private set; }

    public ThingAndPrice(ResourcesTypes typeOfRes, bool isWagon, int xLoc, int yLoc)
    {
        this.TypeOfRes = typeOfRes;
        this.IsWagon = isWagon;
        this.Price = CalculatePrice(xLoc, yLoc);
    }

    private int CalculatePrice(int xLoc, int yLoc)
    {
        if (TypeOfRes == ResourcesTypes.Coal) return 70;
        double price = 0;
        switch (TypeOfRes)
        {
            case ResourcesTypes.Food: 
                price = 3;
                price *= Mathf.Abs(xLoc - yLoc) / 200 * 0.7 + 0.7;
                if (IsWagon) price *= 15;
                break;
            case ResourcesTypes.Ammo:
                price = 10;
                price *= (xLoc + yLoc) / 200 * 0.7 + 0.7;
                if (IsWagon) price *= 10;
                break;
            case ResourcesTypes.Drugs:
                price = 30;
                price *= 1.4 - ((xLoc + yLoc) / 200 * 0.7);
                if (IsWagon) price *= 5;
                break;
            case ResourcesTypes.Luxuries:
                price = 75;
                price *= 1.4 - (Mathf.Abs(xLoc - yLoc) / 200 * 0.7);
                if (IsWagon) price *= 5;
                break;
        }
        price *= Random.Range(0.8f, 1.5f);
        if (price < 1) price = 1;
        return (int)price;
    }

}
